void PROB::setpbt(int type, GCS& gcs) {
	for (int i = 1; i < nnodespv; i++) {
	    int a = Pfr[i];
	    int b = Pto[i];
	    if (b < a) {
		printf("b is less than a in type 1\n");
		getchar();
		std::abort();
	    }
	    double mean = (static_cast<double>(a) + static_cast<double>(b)) / 2.;
	    u::create_poisson_distrb(0, capacitypv, mean, f_i_x[i]);
	    F_i_x[i][0] = f_i_x[i][0];
	    for (int x = 1; x <= capacitypv; x++)
		F_i_x[i][x] = F_i_x[i][x - 1] + f_i_x[i][x];
	    if (fabs(F_i_x[i][capacitypv] - 1.) >= SMALL) {
		printf("Something amiss...check...%f for %d\n", F_i_x[i][capacitypv], i);
		getchar();
		std::abort();
	    }
	}
}

void create_poisson_distrb(int min, int max, double mean, std::vector<double>& pbties) {
	assert(pbties.size() > max);
	if (min < 0)
		min = 0;
	if (max < min)
		max = min;
	boost::math::poisson_distribution<> poisson(mean);
	int significant_max;
	for (int i = 0; i <= max; i++) {
		double pbt = boost::math::pdf(poisson, i);
		if (pbt >= SMALL)
			significant_max = i;
		pbties[i] = pbt;
	}
	double cumulative_left_pbt = 0., cumulative_right_pbt = 0.;
	for (int i = 0; i <= min; i++)
		cumulative_left_pbt += pbties[i];
	for (int i = 0; i < min; i++)
		pbties[i] = 0.;
	pbties[min] = cumulative_left_pbt;//Pbt mass at 0, 1,...,min loaded into min
	for (int i = significant_max; i <= max; i++)
		cumulative_right_pbt += pbties[i];
	for (int i = significant_max + 1; i <= max; i++)
		pbties[i] = 0.;
	pbties[significant_max] = cumulative_right_pbt;//pbt mass at sigmax, sigmax+1,...,max loaded onto sigmax
	double cumulative_pbt = 0.;
	for (int i = min; i <= significant_max; i++)
		cumulative_pbt += pbties[i];
	for (int i = min; i <= significant_max; i++)
		pbties[i] /= cumulative_pbt;
	//sanity check.
	cumulative_pbt = 0.;
	for (int i = 0; i <= max; i++)
		cumulative_pbt += pbties[i];
	if (u::issame(cumulative_pbt, 1.) == false)
		u::Getchexit("Pbties %f not equal to 1.\n", cumulative_pbt);
}

void PROB::readprob(GCS& gcs, std::string file1, FL& fl) {
    /*Format of file
    NumberofCustomers
    Nd DeliveryFrom DeliveryTo RevenuePerUnit XCoord YCoord
    */
    int* coordinatesx = new int[nnodespv];
    int* coordinatesy = new int[nnodespv];
    int n;
    char* s1 = (char*)malloc(file1.size() + 1);
    memcpy(s1, file1.c_str(), file1.size() + 1);
    //FILE* fp1 = fopen(s1, "r");
    FILE* fp1 = 0;
    fopen_s(&fp1, s1, "r");
#ifdef __linux
    int fsc = fscanf(fp1, "%d", &n);
#endif
#ifdef _WIN32
    fscanf_s(fp1, "%d", &n);  //n here is actual number of customers, q is capacity
#endif
    for (int i = 0; i < nnodespv; i++) {  //Then follows n rows representing pickups and deliveries
#ifdef __linux
        int fsc = fscanf(fp1, "%d %d %d %d %d %d", &i, &Pfr[i], &Pto[i], &R[i], &coordinatesx[i], &coordinatesy[i]);
#endif
#ifdef _WIN32
        fscanf_s(fp1, "%d %d %d %d %d %d", &i, &Pfr[i], &Pto[i], &R[i], &coordinatesx[i], &coordinatesy[i]);
#endif
        R[i] = u::return_integer(static_cast<double>(R[i]) * rscalerpv);//rscalerpv is revenue scaler of the paper.
        xcoord[i] = coordinatesx[i];
        ycoord[i] = coordinatesy[i];
    }
    for (int i = 0; i < nnodespv; i++)
        for (int j = 0; j < nnodespv; j++) {
            iCost[i][j] = 0;
            dCost[i][j] = 0.;
        }
    for (int i = 0; i < nnodespv; i++) {  //Then follows N c 2 rows of cost. N is number of customers + 1
        for (int j = i + 1; j < nnodespv; j++) {
            double dist = u::calculate_distance(coordinatesx[i], coordinatesy[i], coordinatesx[j], coordinatesy[j]);
            dCost[j][i] = dCost[i][j] = dist;
            iCost[j][i] = iCost[i][j] = static_cast<int>(dist);
        }
    }
    fclose(fp1);
    free(s1);
    delete[] coordinatesx;
    delete[] coordinatesy;
}

